#!/bin/sh

# -bpython		: Pythonコンポーネントコード生成プログラム
# -bvcproject		: VC++プロジェクトファイル生成プログラム
# -bcxx			: C++コンポーネントコード生成プログラム
#
# --module-name		: モジュール名
# --module-desc		: モジュールの説明
# --module-version	: モジュールのバージョン
# --module-vendor	: モジュールのベンダ
# --module-category	: モジュールのカテゴリ
# --module-comp-type	: コンポーネントの型
# --module-act-type	: アクティビティタイプ
# --module-max-inst	: コンポネントインスタンスの最大数
#
# --inport		: 入力ポート定義
# --outport		: 出力ポート定義
# --service-idl		: サービスプロバイダIDLパス
# --service		: サービスプロバイダ定義
# --consumer-idl	: サービスコンシューマIDLパス
# --consumer		: サービスプロバイダ定義
# --config		: コンフィグレーションセット定義

rtc-template -bcxx \
	--module-name=TestInput \
	--module-desc='Test Input for Coordinate Transformation Module' \
	--module-version=1.0.0 \
	--module-vendor=IRS \
	--module-category=Position \
	--module-comp-type=DataFlowComponent \
	--module-act-type=SPORADIC \
	--module-max-inst=10 \
	--outport=OutJgd2000Position:TimedJgd2000Position \
	--outport=Out19Position:Timed19Position \
	--outport=OutRobotPosition:TimedRobotPosition \
	--consumer-idl=irs.idl \
	--config=01_latitude:double:343940.4787 \
	--config=02_longitude:double:1351256.6632 \
	--config=03_19x:double:-148161.432 \
	--config=04_19y:double:80876.888 \
	--config=05_robotx:double:0 \
	--config=06_roboty:double:0
