/************************************************************************************
coordinatetransformationirs
Copyright (c) 2010, International Rescue System Institute
All rights reserved.

Contact us if you use this software for sell.
If you use this software not for sell, you can use this software under BSD license.
See the files LICENSE.TXT and LICENSE-BSD.TXT for more details.                     
************************************************************************************/

//***************************************************************************************//
//* coordinate.cpp									*//
//***************************************************************************************//


//-- [ヘッダファイル] -------------------------------------------------------------------//
#include "coordinate.h"											// coordinateヘッダファイル読み込み
//---------------------------------------------------------------------------------------//


//-- [座標変換初期化関数] ---------------------------------------------------------------//
//- void trans_init(double *lng, double *lat, double *arc, double *k1, double *k2)	-//
//- 機能  ：平面直角座標系と世界測地系との変換を行うために必要な初期化を行う		-//
//- 引数  ：(double *) 原点経度格納配列ポインタ						-//
//-	  ：(double *) 原点緯度格納配列ポインタ						-//
//-	  ：(double *) 原点子午線弧長格納配列ポインタ					-//
//-	  ：(double *) phi1第2項_分子係数格納配列ポインタ				-//
//-	  ：(double *) phi1第2項_分母第1項係数格納配列ポインタ				-//
//- 戻り値：(void)     なし								-//
//---------------------------------------------------------------------------------------//
void trans_init(double *lng, double *lat, double *arc, double *k1, double *k2)
{
	// 初期化
	* lng       = LNG01;										// 原点01経度格納 [rad]
	*(lng +  1) = LNG02;										// 原点02経度格納 [rad]
	*(lng +  2) = LNG03;										// 原点03経度格納 [rad]
	*(lng +  3) = LNG04;										// 原点04経度格納 [rad]
	*(lng +  4) = LNG05;										// 原点05経度格納 [rad]
	*(lng +  5) = LNG06;										// 原点06経度格納 [rad]
	*(lng +  6) = LNG07;										// 原点07経度格納 [rad]
	*(lng +  7) = LNG08;										// 原点08経度格納 [rad]
	*(lng +  8) = LNG09;										// 原点09経度格納 [rad]
	*(lng +  9) = LNG10;										// 原点10経度格納 [rad]
	*(lng + 10) = LNG11;										// 原点11経度格納 [rad]
	*(lng + 11) = LNG12;										// 原点12経度格納 [rad]
	*(lng + 12) = LNG13;										// 原点13経度格納 [rad]
	*(lng + 13) = LNG14;										// 原点14経度格納 [rad]
	*(lng + 14) = LNG15;										// 原点15経度格納 [rad]
	*(lng + 15) = LNG16;										// 原点16経度格納 [rad]
	*(lng + 16) = LNG17;										// 原点17経度格納 [rad]
	*(lng + 17) = LNG18;										// 原点18経度格納 [rad]
	*(lng + 18) = LNG19;										// 原点19経度格納 [rad]
	* lat       = LAT01;										// 原点01緯度格納 [rad]
	*(lat +  1) = LAT02;										// 原点02緯度格納 [rad]
	*(lat +  2) = LAT03;										// 原点03緯度格納 [rad]
	*(lat +  3) = LAT04;										// 原点04緯度格納 [rad]
	*(lat +  4) = LAT05;										// 原点05緯度格納 [rad]
	*(lat +  5) = LAT06;										// 原点06緯度格納 [rad]
	*(lat +  6) = LAT07;										// 原点07緯度格納 [rad]
	*(lat +  7) = LAT08;										// 原点08緯度格納 [rad]
	*(lat +  8) = LAT09;										// 原点09緯度格納 [rad]
	*(lat +  9) = LAT10;										// 原点10緯度格納 [rad]
	*(lat + 10) = LAT11;										// 原点11緯度格納 [rad]
	*(lat + 11) = LAT12;										// 原点12緯度格納 [rad]
	*(lat + 12) = LAT13;										// 原点13緯度格納 [rad]
	*(lat + 13) = LAT14;										// 原点14緯度格納 [rad]
	*(lat + 14) = LAT15;										// 原点15緯度格納 [rad]
	*(lat + 15) = LAT16;										// 原点16緯度格納 [rad]
	*(lat + 16) = LAT17;										// 原点17緯度格納 [rad]
	*(lat + 17) = LAT18;										// 原点18緯度格納 [rad]
	*(lat + 18) = LAT19;										// 原点19緯度格納 [rad]
	* arc       = ARC01;										// 原点01子午線弧長格納 [m]
	*(arc +  1) = ARC02;										// 原点02子午線弧長格納 [m]
	*(arc +  2) = ARC03;										// 原点03子午線弧長格納 [m]
	*(arc +  3) = ARC04;										// 原点04子午線弧長格納 [m]
	*(arc +  4) = ARC05;										// 原点05子午線弧長格納 [m]
	*(arc +  5) = ARC06;										// 原点06子午線弧長格納 [m]
	*(arc +  6) = ARC07;										// 原点07子午線弧長格納 [m]
	*(arc +  7) = ARC08;										// 原点08子午線弧長格納 [m]
	*(arc +  8) = ARC09;										// 原点09子午線弧長格納 [m]
	*(arc +  9) = ARC10;										// 原点10子午線弧長格納 [m]
	*(arc + 10) = ARC11;										// 原点11子午線弧長格納 [m]
	*(arc + 11) = ARC12;										// 原点12子午線弧長格納 [m]
	*(arc + 12) = ARC13;										// 原点13子午線弧長格納 [m]
	*(arc + 13) = ARC14;										// 原点14子午線弧長格納 [m]
	*(arc + 14) = ARC15;										// 原点15子午線弧長格納 [m]
	*(arc + 15) = ARC16;										// 原点16子午線弧長格納 [m]
	*(arc + 16) = ARC17;										// 原点17子午線弧長格納 [m]
	*(arc + 17) = ARC18;										// 原点18子午線弧長格納 [m]
	*(arc + 18) = ARC19;										// 原点19子午線弧長格納 [m]
	* k1        = K1_01;										// 分子係数格納 [ ]
	*(k1  +  1) = K1_02;										// 分子係数格納 [ ]
	*(k1  +  2) = K1_03;										// 分子係数格納 [ ]
	*(k1  +  3) = K1_04;										// 分子係数格納 [ ]
	*(k1  +  4) = K1_05;										// 分子係数格納 [ ]
	*(k1  +  5) = K1_06;										// 分子係数格納 [ ]
	*(k1  +  6) = K1_07;										// 分子係数格納 [ ]
	*(k1  +  7) = K1_08;										// 分子係数格納 [ ]
	*(k1  +  8) = K1_09;										// 分子係数格納 [ ]
	*(k1  +  9) = K1_10;										// 分子係数格納 [ ]
	*(k1  + 10) = K1_11;										// 分子係数格納 [ ]
	*(k1  + 11) = K1_12;										// 分子係数格納 [ ]
	*(k1  + 12) = K1_13;										// 分子係数格納 [ ]
	*(k1  + 13) = K1_14;										// 分子係数格納 [ ]
	*(k1  + 14) = K1_15;										// 分子係数格納 [ ]
	*(k1  + 15) = K1_16;										// 分子係数格納 [ ]
	*(k1  + 16) = K1_17;										// 分子係数格納 [ ]
	*(k1  + 17) = K1_18;										// 分子係数格納 [ ]
	*(k1  + 18) = K1_19;										// 分子係数格納 [ ]
	* k2        = K2_01;										// 分母第1項係数格納 [ ]
	*(k2  +  1) = K2_02;										// 分母第1項係数格納 [ ]
	*(k2  +  2) = K2_03;										// 分母第1項係数格納 [ ]
	*(k2  +  3) = K2_04;										// 分母第1項係数格納 [ ]
	*(k2  +  4) = K2_05;										// 分母第1項係数格納 [ ]
	*(k2  +  5) = K2_06;										// 分母第1項係数格納 [ ]
	*(k2  +  6) = K2_07;										// 分母第1項係数格納 [ ]
	*(k2  +  7) = K2_08;										// 分母第1項係数格納 [ ]
	*(k2  +  8) = K2_09;										// 分母第1項係数格納 [ ]
	*(k2  +  9) = K2_10;										// 分母第1項係数格納 [ ]
	*(k2  + 10) = K2_11;										// 分母第1項係数格納 [ ]
	*(k2  + 11) = K2_12;										// 分母第1項係数格納 [ ]
	*(k2  + 12) = K2_13;										// 分母第1項係数格納 [ ]
	*(k2  + 13) = K2_14;										// 分母第1項係数格納 [ ]
	*(k2  + 14) = K2_15;										// 分母第1項係数格納 [ ]
	*(k2  + 15) = K2_16;										// 分母第1項係数格納 [ ]
	*(k2  + 16) = K2_17;										// 分母第1項係数格納 [ ]
	*(k2  + 17) = K2_18;										// 分母第1項係数格納 [ ]
	*(k2  + 18) = K2_19;										// 分母第1項係数格納 [ ]

	return;												// 戻り値

}


//-- [世界測地系座標変換関数] -----------------------------------------------------------//
//- void trans_world(double x, double y, int n, double *phi, double *lambda,		-//
//-	double *lng, double *lat, double *arc, double *k1, double *k2)			-//
//- 機能  ：平面直角座標系から世界測地系へ変換を行う					-//
//- 引数  ：(double)   平面直角座標系x座標 [m]						-//
//-	  ：(double)   平面直角座標系y座標 [m]						-//
//-	  ：(int)      平面直角座標系原点 [ ]						-//
//-	  ：(double *) 世界測地系緯度 [rad]						-//
//-	  ：(double *) 世界測地系経度 [rad]						-//
//-	  ：(double *) 原点経度格納配列ポインタ						-//
//-	  ：(double *) 原点緯度格納配列ポインタ						-//
//-	  ：(double *) 原点子午線弧長格納配列ポインタ					-//
//-	  ：(double *) phi1第2項_分子係数格納配列ポインタ				-//
//-	  ：(double *) phi1第2項_分母第1項係数格納配列ポインタ				-//
//- 戻り値：(void)     なし								-//
//---------------------------------------------------------------------------------------//
void trans_world(double x, double y, int n, double *phi, double *lambda, double *lng, double *lat, double *arc, double *k1, double *k2)
{
	// 変数宣言
	double m;											// 計算過程格納変数 [m]
	double s;											// 求点子午線弧長格納変数 [m]
	double phi1_old;										// 旧phi1格納変数 [rad]
	double phi1_new;										// 新phi1格納変数 [rad]
	double ita1_2;											// ita1二乗格納変数 [ ]
	double t1;											// t1格納変数 [ ]
	double n1_2;											// 卯酉線曲率半径二乗格納変数 [m^2]

	// 初期化
	phi1_old = - 1.0;										// 旧phi1初期化
	n--;												// 配列番号変換

	// phi1初期化
	m = *(arc + n) + x / M0;									// M算出
	phi1_new = *(lat + n);										// phi1格納

	// phi1算出
	while(fabs(phi1_new - phi1_old) >= ERROR){							// 残差チェック

		// 求点子午線孤長算出
		s = B1 * phi1_new + B2 * sin( 2.0 * phi1_new) + B3 * sin( 4.0 * phi1_new)
				  + B4 * sin( 6.0 * phi1_new) + B5 * sin( 8.0 * phi1_new)
				  + B6 * sin(10.0 * phi1_new) + B7 * sin(12.0 * phi1_new)
				  + B8 * sin(14.0 * phi1_new) + B9 * sin(16.0 * phi1_new);		// S(phin)算出

		// phi1算出
		phi1_old = phi1_new;									// phi1格納
		phi1_new = phi1_old + *(k1 + n) * (s - m) / (*(k2 + n) * (s - m) + TERM);		// phi1算出

	}

	// 係数算出
	ita1_2 = E2_2 * cos(phi1_new) * cos(phi1_new);							// ita1_2算出
	t1 = tan(phi1_new);										// t1算出
	n1_2 = A2 / (1.0 - E1_2 * sin(phi1_new) * sin(phi1_new));					// n1_2算出

	// phi算出
	*phi = phi1_new - t1 * (1.0 + ita1_2) * pow((y / M0), 2.0) / (2.0 * n1_2)
	      + t1 * (5.0 + 3.0 * pow(t1, 2.0) + 6.0 * ita1_2 - 6.0 * pow(t1, 2.0) * ita1_2 - 3.0 * pow(ita1_2, 2.0)
		- 9.0 * pow(t1, 2.0) * pow(ita1_2, 2.0)) * pow((y / M0), 4.0) / (24.0 * pow(n1_2, 2.0))
	      - t1 * (61.0 + 90.0 * pow(t1, 2.0) + 45.0 * pow(t1, 4.0) + 107.0 * ita1_2 - 162.0 * pow(t1, 2.0) * ita1_2
		- 45.0 * pow(t1, 4.0) * ita1_2)	* pow((y / M0), 6.0) / (720.0 * pow(n1_2, 3.0))
	      + t1 * (1385.0 + 3633.0 * pow(t1, 2.0) + 4095.0 * pow(t1, 4.0) + 1575.0 * pow(t1, 6.0))
		* pow((y / M0), 8.0) / (40320.0 * pow(n1_2, 4.0));					// phi算出

	// lambda算出
	*lambda = *(lng + n) + (y / M0) / (pow((n1_2), 0.5) * cos(phi1_new))
		- (1.0 + 2.0 * pow(t1, 2.0) + ita1_2) * pow((y / M0), 3.0) / (6.0 * pow(n1_2, 1.5) * cos(phi1_new))
		+ (5.0 + 28.0 * pow(t1, 2.0) + 24.0 * pow(t1, 4.0) + 6.0 * ita1_2 + 8.0 * pow(t1, 2.0) * ita1_2)
			* pow((y / M0), 5.0) / (120.0 * pow(n1_2, 2.5) * cos(phi1_new))
		- (61.0 + 662.0 * pow(t1, 2.0)+ 1320.0 * pow(t1, 4.0) + 720.0 * pow(t1, 6.0))
			* pow((y / M0), 7.0) / (5040.0 * pow(n1_2, 3.5) * cos(phi1_new));		// lambda算出

	return;												// 戻り値

}


//-- [平面直角座標系座標変換関数] -------------------------------------------------------//
//- void trans_19(double phi, double lambda, int n, double *x, double *y,		-//
//-	double *lng, double *lat)							-//
//- 機能  ：世界測地系から平面直角座標系へ変換を行う					-//
//- 引数  ：(double)   世界測地系緯度 [rad]						-//
//-	  ：(double)   世界測地系経度 [rad]						-//
//-	  ：(int)      平面直角座標系原点 [ ]						-//
//-	  ：(double *) 平面直角座標系x座標 [m]						-//
//-	  ：(double *) 平面直角座標系y座標 [m]						-//
//-	  ：(double *) 原点経度格納配列ポインタ						-//
//-	  ：(double *) 原点緯度格納配列ポインタ						-//
//- 戻り値：(void)     なし								-//
//---------------------------------------------------------------------------------------//
void trans_19(double phi, double lambda, int n, double *x, double *y, double *lng, double *lat)
{
	// 変数宣言
	double s0;											// 原点子午線弧長格納変数 [m]
	double s;											// 求点子午線弧長格納変数 [m]
	double d_lambda;										// 経度差分格納変数 [rad]
	double ita_2;											// ita二乗格納変数 [ ]
	double t;											// t格納変数 [ ]
	double n_phi;											// 卯酉線曲率半径格納変数 [m]

	// 初期化
	n--;												// 配列番号変換

	// 原点子午線孤長算出
	s0 = B1 * *(lat + n) + B2 * sin( 2.0 * *(lat + n)) + B3 * sin( 4.0 * *(lat + n))
			     + B4 * sin( 6.0 * *(lat + n)) + B5 * sin( 8.0 * *(lat + n))
			     + B6 * sin(10.0 * *(lat + n)) + B7 * sin(12.0 * *(lat + n))
			     + B8 * sin(14.0 * *(lat + n)) + B9 * sin(16.0 * *(lat + n));		// S(phi0)算出

	// 求点子午線孤長算出
	s = B1 * phi + B2 * sin( 2.0 * phi) + B3 * sin( 4.0 * phi)
		     + B4 * sin( 6.0 * phi) + B5 * sin( 8.0 * phi)
		     + B6 * sin(10.0 * phi) + B7 * sin(12.0 * phi)
		     + B8 * sin(14.0 * phi) + B9 * sin(16.0 * phi);					// S(phi)算出

	// 係数算出
	d_lambda = lambda - *(lng + n);									// d_lambda算出
	ita_2 = E2_2 * cos(phi) * cos(phi);								// ita_2算出
	t = tan(phi);											// t算出
	n_phi = pow((A2 / (1.0 - E1_2 * sin(phi) * sin(phi))), 0.5);					// n算出

	// x算出
	*x = ((s - s0) + n_phi * pow(cos(phi), 2.0) * t * pow(d_lambda, 2.0) / 2.0
		       + n_phi * pow(cos(phi), 4.0) * t *
			(5.0 - pow(t, 2.0) + 9.0 * ita_2 + 4 * pow(ita_2, 2.0)) * pow(d_lambda, 4.0) / 24.0
		       - n_phi * pow(cos(phi), 6.0) * t *
			(- 61.0 + 58.0 * pow(t, 2.0) - pow(t, 4.0) - 270.0 * ita_2
			+ 330.0 * pow(t, 2.0) * ita_2 ) * pow(d_lambda, 6.0) / 720.0
		       - n_phi * pow(cos(phi), 8.0) * t *
			(- 1385.0 + 3111.0 * pow(t, 2.0) - 543.0 * pow(t, 4.0)
			+ pow(t, 6.0)) * pow(d_lambda, 8.0) / 40320.0) * M0;				// x算出

	// y算出
	*y = (  n_phi * cos(phi) * d_lambda
	      - n_phi * pow(cos(phi), 3.0) * (- 1.0 + pow(t, 2.0) - ita_2)
		* pow(d_lambda, 3.0) / 6.0
	      - n_phi * pow(cos(phi), 5.0) * (- 5.0 + 18.0 * pow(t, 2.0) - pow(t, 4.0) - 14.0 * ita_2 + 58.0 * pow(t, 2.0) * ita_2)
		* pow(d_lambda, 5.0) / 120.0
	      - n_phi * pow(cos(phi), 7.0) * (- 61.0 + 479.0 * pow(t, 2.0) - 179.0 * pow(t, 4.0) + pow(t, 6.0))
		* pow(d_lambda, 7.0) / 5040.0) * M0;							// y算出

	return;												// 戻り値

}
